Option Explicit

Sub CompareFolder(sourceFolder, destinationFolder)
	Dim found
	Dim equal
	Dim sourceFiles
	Dim sourceFile
	Dim sourcePath
	Dim destinationPath
	Dim destinationFile
	Dim destinationFileName
	Dim sourceDate
	Dim destinationDate
	Dim sourceSubFolder
	Dim sourceSubFolders
	Dim destinationSubFolder
	Dim destinationSubFolders

	Set sourceFiles = sourceFolder.Files
	Set sourceSubFolders = sourceFolder.SubFolders

	For Each sourceFile in sourceFiles
		found = false
		equal = false

		sourcePath = g_fso.GetAbsolutePathName(sourceFile)
		destinationPath = g_fso.GetAbsolutePathName(destinationFolder)
		destinationPath = g_fso.BuildPath(destinationPath, sourceFile.Name)

		If g_fso.FileExists(destinationPath) = 0 Then
			PrintLine sourceFile.Name & " is not found"
			g_fso.CopyFile sourcePath, destinationPath
		Else
			Set destinationFile = g_fso.GetFile(destinationPath)
			sourceDate = sourceFile.DateLastModified
			destinationDate = destinationFile.DateLastModified

			If IsOldFile(destinationDate, sourceDate) = -1 Then
				PrintLine sourceFile.Name & " is out of date"
				g_fso.CopyFile sourcePath, destinationPath
			End if
		End If
	Next

	For Each sourceSubFolder in sourceSubFolders
		sourcePath = g_fso.GetAbsolutePathName(sourceSubFolder)
		destinationPath = g_fso.GetAbsolutePathName(destinationFolder)
		destinationPath = g_fso.BuildPath(destinationPath, sourceSubFolder.Name)
		If g_fso.FolderExists(destinationPath) = 0 Then
			PrintLine sourceSubFolder.Name & " is not found"
			g_fso.CreateFolder destinationPath
		End If
		Set DestinationSubFolder = g_fso.GetFolder(destinationPath)
		CompareFolder SourceSubFolder, DestinationSubFolder
	Next
End Sub
